﻿/*
DNNAN의 배포 스크립트

이 코드는 도구를 사용하여 생성되었습니다.
파일 내용을 변경하면 잘못된 동작이 발생할 수 있으며, 코드를 다시 생성하면
변경 내용이 손실됩니다.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "DNNAN"
:setvar DefaultFilePrefix "DNNAN"
:setvar DefaultDataPath "C:\Users\RedPlus\AppData\Local\Microsoft\Microsoft SQL Server Local DB\Instances\MSSQLLocalDb"
:setvar DefaultLogPath "C:\Users\RedPlus\AppData\Local\Microsoft\Microsoft SQL Server Local DB\Instances\MSSQLLocalDb"

GO
:on error exit
GO
/*
SQLCMD 모드가 지원되지 않으면 SQLCMD 모드를 검색하고 스크립트를 실행하지 않습니다.
SQLCMD 모드를 설정한 후에 이 스크립트를 다시 사용하려면 다음을 실행합니다.
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'이 스크립트를 실행하려면 SQLCMD 모드를 사용하도록 설정해야 합니다.';
        SET NOEXEC ON;
    END


GO
USE [master];


GO

IF (DB_ID(N'$(DatabaseName)') IS NOT NULL) 
BEGIN
    ALTER DATABASE [$(DatabaseName)]
    SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
    DROP DATABASE [$(DatabaseName)];
END

GO
PRINT N'$(DatabaseName)을(를) 만드는 중...'
GO
CREATE DATABASE [$(DatabaseName)]
    ON 
    PRIMARY(NAME = [$(DatabaseName)], FILENAME = N'$(DefaultDataPath)$(DefaultFilePrefix)_Primary.mdf')
    LOG ON (NAME = [$(DatabaseName)_log], FILENAME = N'$(DefaultLogPath)$(DefaultFilePrefix)_Primary.ldf') COLLATE SQL_Latin1_General_CP1_CI_AS
GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET ANSI_NULLS ON,
                ANSI_PADDING ON,
                ANSI_WARNINGS ON,
                ARITHABORT ON,
                CONCAT_NULL_YIELDS_NULL ON,
                NUMERIC_ROUNDABORT OFF,
                QUOTED_IDENTIFIER ON,
                ANSI_NULL_DEFAULT ON,
                CURSOR_DEFAULT LOCAL,
                CURSOR_CLOSE_ON_COMMIT OFF,
                AUTO_CREATE_STATISTICS ON,
                AUTO_SHRINK OFF,
                AUTO_UPDATE_STATISTICS ON,
                RECURSIVE_TRIGGERS OFF 
            WITH ROLLBACK IMMEDIATE;
        ALTER DATABASE [$(DatabaseName)]
            SET AUTO_CLOSE OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET ALLOW_SNAPSHOT_ISOLATION OFF;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET READ_COMMITTED_SNAPSHOT OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET AUTO_UPDATE_STATISTICS_ASYNC OFF,
                PAGE_VERIFY NONE,
                DATE_CORRELATION_OPTIMIZATION OFF,
                DISABLE_BROKER,
                PARAMETERIZATION SIMPLE,
                SUPPLEMENTAL_LOGGING OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF IS_SRVROLEMEMBER(N'sysadmin') = 1
    BEGIN
        IF EXISTS (SELECT 1
                   FROM   [master].[dbo].[sysdatabases]
                   WHERE  [name] = N'$(DatabaseName)')
            BEGIN
                EXECUTE sp_executesql N'ALTER DATABASE [$(DatabaseName)]
    SET TRUSTWORTHY OFF,
        DB_CHAINING OFF 
    WITH ROLLBACK IMMEDIATE';
            END
    END
ELSE
    BEGIN
        PRINT N'데이터베이스 설정을 수정할 수 없습니다. 이러한 설정을 적용하려면 SysAdmin이어야 합니다.';
    END


GO
IF IS_SRVROLEMEMBER(N'sysadmin') = 1
    BEGIN
        IF EXISTS (SELECT 1
                   FROM   [master].[dbo].[sysdatabases]
                   WHERE  [name] = N'$(DatabaseName)')
            BEGIN
                EXECUTE sp_executesql N'ALTER DATABASE [$(DatabaseName)]
    SET HONOR_BROKER_PRIORITY OFF 
    WITH ROLLBACK IMMEDIATE';
            END
    END
ELSE
    BEGIN
        PRINT N'데이터베이스 설정을 수정할 수 없습니다. 이러한 설정을 적용하려면 SysAdmin이어야 합니다.';
    END


GO
ALTER DATABASE [$(DatabaseName)]
    SET TARGET_RECOVERY_TIME = 0 SECONDS 
    WITH ROLLBACK IMMEDIATE;


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET FILESTREAM(NON_TRANSACTED_ACCESS = OFF),
                CONTAINMENT = NONE 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET AUTO_CREATE_STATISTICS ON(INCREMENTAL = OFF),
                MEMORY_OPTIMIZED_ELEVATE_TO_SNAPSHOT = OFF,
                DELAYED_DURABILITY = DISABLED 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET QUERY_STORE (QUERY_CAPTURE_MODE = ALL, FLUSH_INTERVAL_SECONDS = 900, INTERVAL_LENGTH_MINUTES = 60, MAX_PLANS_PER_QUERY = 200, CLEANUP_POLICY = (STALE_QUERY_THRESHOLD_DAYS = 367), MAX_STORAGE_SIZE_MB = 100) 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE [$(DatabaseName)]
            SET QUERY_STORE = OFF 
            WITH ROLLBACK IMMEDIATE;
    END


GO
IF EXISTS (SELECT 1
           FROM   [master].[dbo].[sysdatabases]
           WHERE  [name] = N'$(DatabaseName)')
    BEGIN
        ALTER DATABASE SCOPED CONFIGURATION SET MAXDOP = 0;
        ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET MAXDOP = PRIMARY;
        ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = OFF;
        ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET LEGACY_CARDINALITY_ESTIMATION = PRIMARY;
        ALTER DATABASE SCOPED CONFIGURATION SET PARAMETER_SNIFFING = ON;
        ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET PARAMETER_SNIFFING = PRIMARY;
        ALTER DATABASE SCOPED CONFIGURATION SET QUERY_OPTIMIZER_HOTFIXES = OFF;
        ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET QUERY_OPTIMIZER_HOTFIXES = PRIMARY;
    END


GO
USE [$(DatabaseName)];


GO
IF fulltextserviceproperty(N'IsFulltextInstalled') = 1
    EXECUTE sp_fulltext_database 'enable';


GO
PRINT N'[dbo].[Addresses]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Addresses] (
    [Id]            INT          IDENTITY (1, 1) NOT NULL,
    [ContactId]     INT          NOT NULL,
    [AddressType]   VARCHAR (10) NOT NULL,
    [StreetAddress] VARCHAR (50) NOT NULL,
    [City]          VARCHAR (50) NOT NULL,
    [StateId]       INT          NOT NULL,
    [PostalCode]    VARCHAR (20) NOT NULL,
    CONSTRAINT [PK_Addresses] PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Boards]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Boards] (
    [TID]          INT            IDENTITY (1, 1) NOT NULL,
    [BoardAlias]   NVARCHAR (50)  NULL,
    [Title]        NVARCHAR (50)  NULL,
    [Description]  NVARCHAR (200) NULL,
    [SysopUID]     INT            NULL,
    [IsPublic]     BIT            NULL,
    [GroupName]    NVARCHAR (50)  NULL,
    [GroupOrder]   INT            NULL,
    [MailEnable]   BIT            NULL,
    [ShowList]     BIT            NULL,
    [BoardStyle]   INT            NULL,
    [HeaderHtml]   NVARCHAR (MAX) NULL,
    [FooterHtml]   NVARCHAR (MAX) NULL,
    [MainShowList] INT            NULL,
    PRIMARY KEY CLUSTERED ([TID] ASC)
);


GO
PRINT N'[dbo].[Contacts]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Contacts] (
    [Id]        INT          IDENTITY (1, 1) NOT NULL,
    [FirstName] VARCHAR (50) NULL,
    [LastName]  VARCHAR (50) NULL,
    [Email]     VARCHAR (50) NULL,
    [Company]   VARCHAR (50) NULL,
    [Title]     VARCHAR (50) NULL,
    CONSTRAINT [PK_Contacts] PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Domains]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Domains] (
    [UID]         INT            IDENTITY (1, 1) NOT NULL,
    [DomainID]    NVARCHAR (30)  NOT NULL,
    [Name]        NVARCHAR (50)  NOT NULL,
    [Type]        NVARCHAR (10)  NOT NULL,
    [Description] NVARCHAR (255) NULL,
    [CreatedDate] DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([UID] ASC)
);


GO
PRINT N'[dbo].[Logs]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Logs] (
    [Id]              INT                IDENTITY (1, 1) NOT NULL,
    [Note]            NVARCHAR (MAX)     NULL,
    [Application]     NVARCHAR (50)      NULL,
    [Logger]          NVARCHAR (255)     NULL,
    [LogEvent]        NVARCHAR (MAX)     NULL,
    [Message]         NVARCHAR (MAX)     NULL,
    [MessageTemplate] NVARCHAR (MAX)     NULL,
    [Level]           NVARCHAR (128)     NULL,
    [TimeStamp]       DATETIMEOFFSET (7) NOT NULL,
    [Exception]       NVARCHAR (MAX)     NULL,
    [Properties]      XML                NULL,
    [Callsite]        NVARCHAR (MAX)     NULL,
    [IpAddress]       NVARCHAR (20)      NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Menus]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Menus] (
    [MenuId]      INT            IDENTITY (1, 1) NOT NULL,
    [MenuOrder]   INT            NOT NULL,
    [ParentId]    INT            NULL,
    [MenuName]    NVARCHAR (100) NOT NULL,
    [MenuPath]    NVARCHAR (255) NULL,
    [IsVisible]   BIT            NOT NULL,
    [CommunityId] INT            NULL,
    [IsBoard]     BIT            NOT NULL,
    [Target]      NVARCHAR (20)  NULL,
    [BoardAlias]  NVARCHAR (50)  NULL,
    PRIMARY KEY CLUSTERED ([MenuId] ASC)
);


GO
PRINT N'[dbo].[Messages]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Messages] (
    [MessageId]     INT            IDENTITY (1, 1) NOT NULL,
    [SenderId]      INT            NULL,
    [SenderName]    VARCHAR (30)   NULL,
    [RecipientId]   INT            NULL,
    [RecipientName] VARCHAR (30)   NULL,
    [Title]         VARCHAR (140)  NULL,
    [Content]       VARCHAR (1000) NULL,
    [PostDate]      DATETIME       NULL,
    [ReadDate]      DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([MessageId] ASC)
);


GO
PRINT N'[dbo].[Permission]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Permission] (
    [TID]         INT NOT NULL,
    [UID]         INT NOT NULL,
    [NoAccess]    BIT NULL,
    [List]        BIT NULL,
    [ReadArticle] BIT NULL,
    [Download]    BIT NULL,
    [Write]       BIT NULL,
    [Upload]      BIT NULL,
    [Extra]       BIT NULL,
    [Admin]       BIT NULL,
    [Comment]     BIT NULL,
    PRIMARY KEY CLUSTERED ([TID] ASC, [UID] ASC)
);


GO
PRINT N'[dbo].[States]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[States] (
    [Id]        INT          NOT NULL,
    [StateName] VARCHAR (50) NOT NULL,
    CONSTRAINT [PK_States] PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[UserProfiles]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[UserProfiles] (
    [Id]            INT                IDENTITY (1, 1) NOT NULL,
    [UID]           INT                NOT NULL,
    [Password]      NVARCHAR (50)      NULL,
    [Email]         NVARCHAR (100)     NULL,
    [LastLoginDate] DATETIME           NULL,
    [LastLoginIP]   NVARCHAR (16)      NULL,
    [VisitedCount]  INT                NULL,
    [Blocked]       BIT                NULL,
    [PhoneNumber]   NVARCHAR (30)      NULL,
    [Address]       NVARCHAR (500)     NULL,
    [Gender]        NVARCHAR (10)      NULL,
    [BirthDate]     NVARCHAR (20)      NULL,
    [Country]       NVARCHAR (50)      NULL,
    [IsSleep]       BIT                NULL,
    [SleepDate]     DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((0)) FOR [SysopUID];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((1)) FOR [IsPublic];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((0)) FOR [GroupOrder];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((0)) FOR [MailEnable];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((1)) FOR [ShowList];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT ((0)) FOR [BoardStyle];


GO
PRINT N'[dbo].[Boards]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Boards]
    ADD DEFAULT (1) FOR [MainShowList];


GO
PRINT N'[dbo].[Domains]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Domains]
    ADD DEFAULT (GetDate()) FOR [CreatedDate];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT (0) FOR [ParentId];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT (1) FOR [IsVisible];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT (1) FOR [CommunityId];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT (1) FOR [IsBoard];


GO
PRINT N'[dbo].[Menus]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Menus]
    ADD DEFAULT ('_self') FOR [Target];


GO
PRINT N'[dbo].[Messages]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Messages]
    ADD DEFAULT (GetDate()) FOR [PostDate];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (0) FOR [NoAccess];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [List];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [ReadArticle];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [Download];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [Write];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [Upload];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (0) FOR [Extra];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (0) FOR [Admin];


GO
PRINT N'[dbo].[Permission]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Permission]
    ADD DEFAULT (1) FOR [Comment];


GO
PRINT N'[dbo].[UserProfiles]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[UserProfiles]
    ADD DEFAULT (0) FOR [VisitedCount];


GO
PRINT N'[dbo].[UserProfiles]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[UserProfiles]
    ADD DEFAULT (0) FOR [Blocked];


GO
PRINT N'[dbo].[UserProfiles]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[UserProfiles]
    ADD DEFAULT (0) FOR [IsSleep];


GO
PRINT N'[dbo].[UserProfiles]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[UserProfiles]
    ADD DEFAULT (GetDate()) FOR [SleepDate];


GO
PRINT N'[dbo].[FK_Addresses_Contacts]을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Addresses]
    ADD CONSTRAINT [FK_Addresses_Contacts] FOREIGN KEY ([ContactId]) REFERENCES [dbo].[Contacts] ([Id]) ON DELETE CASCADE;


GO
PRINT N'[dbo].[FK_Addresses_States]을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Addresses]
    ADD CONSTRAINT [FK_Addresses_States] FOREIGN KEY ([StateId]) REFERENCES [dbo].[States] ([Id]);


GO
PRINT N'[dbo].[BoardViews]을(를) 만드는 중...';


GO
CREATE VIEW [dbo].[BoardViews]
AS 
	SELECT 
		[TID] As BoardId, 
		[BoardAlias], 
		[Title], 
		[Description], 
		[SysopUID] As SysopUsername, 
		[IsPublic], 
		[GroupName], 
		[GroupOrder], 
		[MailEnable], 
		[ShowList], 
		[BoardStyle], 
		[HeaderHtml], 
		[FooterHtml], 
		[MainShowList] 
	FROM [Boards]
GO
PRINT N'[dbo].[Users]을(를) 만드는 중...';


GO
------------------------------------------------------------------------------------------------------
--[!] 뷰(View) 설계 - 회원 인증 관련
------------------------------------------------------------------------------------------------------

--[2] 사용자 리스트 : Users 뷰
--    /Models/User.cs 
--    /ViewModels/UserViewModel.cs 
Create View dbo.Users
As
    Select 
        Domains.UID As UID, 
        Domains.DomainID As DomainID,
        Domains.Name As Name,
        Domains.CreatedDate As CreatedDate,
        UserProfiles.Password As Password,
        UserProfiles.Email As Email,
        UserProfiles.LastLoginDate As LastLoginDate,
        UserProfiles.LastLoginIP As LastLoginIP,
        UserProfiles.VisitedCount As VisitedCount,
        Domains.Description As Description,
        UserProfiles.Blocked As Blocked,
        Domains.Type As Type, -- TODO: Type 대신 DomainType으로 사용

        UserProfiles.PhoneNumber	As PhoneNumber,
        UserProfiles.Address		As Address,
        UserProfiles.Gender			As Gender,
        UserProfiles.BirthDate		As BirthDate,
        UserProfiles.Country		As Country		
    From 
        Domains Join UserProfiles
        On	
            Domains.UID = UserProfiles.UID
    Where 
        Domains.Type = 'User'
    With Check Option
GO
PRINT N'[dbo].[AddNewGroup]을(를) 만드는 중...';


GO
--[10] 그룹을 추가하는 저장 프로시저 : AddNewGroup
Create Proc dbo.AddNewGroup
    @GroupUID NVarChar(50),
    @Name NVarChar(50),
    @Description NVarChar(255),
    --
    @UID Int Output
As
    --[!] 해당 그룹이 이미 등록되어있으면
    Declare @Result Int
    Select @Result = Count(*) From Domains Where DomainID = @GroupUID

    If @Result > 0 
        Return -1 -- -1이 반환되면 회원가입 안됨...

    Insert Domains(DomainID, Name, Description, Type)
    Values(@GroupUID, @Name, @Description, 'Group')

    Select @UID = @@Identity -- Domains 테이블의 가장 마지막 입력된 UID값

    --[!] UID값 반환
    Select @UID
GO
PRINT N'[dbo].[AddUser]을(를) 만드는 중...';


GO
------------------------------------------------------------------------------------------------------
--[!] 저장 프로시저(Stored Procedure) 설계 - 회원 인증 관련
------------------------------------------------------------------------------------------------------

--[1] 회원 가입 저장 프로시저 : UserRepository.AddUserUpgrade()와 Register.aspx에서 사용
Create Proc dbo.AddUser
    @DomainID			NVarChar(30),
    @Name				NVarChar(50),
    @Description		NVarChar(255), 
    --	
    @Password			NVarChar(50),
    @Email				NVarChar(100),
    @Blocked			Bit, 
    @GroupUID			Int,				-- 기본은 'Users' 그룹 권한의 UID값, 'Administrators', 'Users', 'Guests' 중 'Users'의 고유 UID 값
    --
    @UID				Int Output,			-- 반환형 매개변수

    -- 추가된 매개변수
    @PhoneNumber		NVarChar(30),
    @Address			NVarChar(140),
    @Gender				NVarChar(5), 
    @BirthDate			NVarChar(12),
    @Country			NVarChar(30)
As
    If @UID Is Null
        Set @UID = 0

    --[!] 해당 아이디가 이미 회원가입되어있으면
    Declare @Result Int
    Select @Result = Count(*) From Domains Where DomainID = @DomainID

    If @Result > 0 
        Return -1 -- -1이 반환되면 회원가입 안됨...

    --[a] Domains 테이블에 데이터 입력
    If @Description <> '' 
        Insert Domains (DomainID, Name, Type, Description) 
        Values(@DomainID, @Name, 'User', @Description)	
    Else
        Insert Domains (DomainID, Name, Type, Description) 
        Values(@DomainID, @Name, 'User', NULL)	
    
    -- Select @UID = @@Identity -- Domains 테이블의 가장 마지막 입력된 UID값
	Select @UID = SCOPE_IDENTITY() -- 

    --[b] UserProfiles 테이블에 데이터 입력
    If @Email <> '' 
        Insert UserProfiles (UID, Password, Email, LastLoginDate, LastLoginIP, VisitedCount, Blocked, PhoneNumber, Address, Gender, BirthDate, Country)
        Values (@UID, @Password, @Email, Null, Null, 0, @Blocked, @PhoneNumber, @Address, @Gender, @BirthDate, @Country)
    Else
        Insert UserProfiles (UID, Password, Email, LastLoginDate, LastLoginIP, VisitedCount, Blocked, PhoneNumber, Address, Gender, BirthDate, Country)
        Values (@UID, @Password, Null, Null, Null, 0, @Blocked, @PhoneNumber, @Address, @Gender, @BirthDate, @Country)
    
    SELECT UID FROM Domains WHERE DomainID = 'Users'

    --[c] Membership 테이블에 데이터 입력
    Insert Membership (UserUID, GroupUID) 
    Values(@UID, @GroupUID) -- 모든 회원은 기본이 Users 권한

    --[!] UID값 반환
    -- Select @UID
GO
PRINT N'[dbo].[ChangePassword]을(를) 만드는 중...';


GO
--[5] 현재 사용자에 대한 암호 변경 기능 구현 : ChangePassword
Create Proc dbo.ChangePassword
    @OriginalPassword NVarChar(20),	-- 이전 암호
    @NewPassword NVarChar(20),		-- 새 암호
    @DomainID NVarChar(30)			-- 현재 접속자 아이디
As
    Declare @UID Int
    Select @UID = UID From Users
    Where DomainID = @DomainID And Password = @OriginalPassword

    If @UID > 0
    Begin
        Update UserProfiles
        Set Password = @NewPassword
        Where UID = @UID
        Return 1 -- 업데이트 함	
        --Select @@RowCount
    End	
    Else
        Return -1 -- -1이 반환되면 업데이트 미적용
GO
PRINT N'[dbo].[DeleteAddress]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[DeleteAddress]
	@Id int
AS
BEGIN
	DELETE FROM Addresses WHERE Id = @Id;
END;
GO
PRINT N'[dbo].[DeleteContact]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[DeleteContact]
	@Id int
AS
BEGIN
	DELETE FROM Contacts
	WHERE Id = @Id;
END;
GO
PRINT N'[dbo].[DeleteUser]을(를) 만드는 중...';


GO
--[4] 현재 접속자에 대한 회원탈퇴 기능 구현 : DeleteUser : UserInfor.aspx에서 사용
Create Proc dbo.DeleteUser
    @DomainID NVarChar(30)
As
    Declare @UID Int
    Select @UID = UID From Users Where DomainID = @DomainID

    If @UID Is Not Null
    Begin
        Delete Domains Where UID = @UID And Type = 'User'
        Delete UserProfiles Where UID = @UID
        Delete Membership Where UserUID = @UID
        -- 게시판 연동시 2개 정도의 테이블에 있는 정보도 삭제
        --If OBJECT_ID(N'Permission', N'U') Is Not Null
        --Begin
        --	Delete From Permission Where UID = @UID
        --End
        --If OBJECT_ID(N'MailList', N'U') Is Not Null
        --Begin
     --       Delete From MailList Where UID = @UID
        --End
    End
GO
PRINT N'[dbo].[GetContact]을(를) 만드는 중...';


GO
CREATE procedure [dbo].[GetContact]
	@Id int
AS
BEGIN
	SELECT [Id]
		  ,[FirstName]
		  ,[LastName]
		  ,[Company]
		  ,[Title]
		  ,[Email]
	  FROM [dbo].[Contacts]
	WHERE Id = @Id;

	SELECT 
		Id,
		ContactId,
		AddressType,
		StreetAddress,
		City,
		StateId,
		PostalCode
	FROM [dbo].[Addresses] 
	WHERE ContactID = @Id;

END
GO
PRINT N'[dbo].[GetGroupByUID]을(를) 만드는 중...';


GO
--TODO: 
--[8] 현재 접속자에 포함된 그룹 정보 읽어오기
Create Proc dbo.GetGroupByUID
    @UID Int
As
    Select GroupUID, DomainID, Name
    From Membership, Groups 
    Where 
        Membership.GroupUID = Groups.UID
        And
        Membership.UserUID = @UID
    Order By DomainID Asc
GO
PRINT N'[dbo].[GetGroupNotInUse]을(를) 만드는 중...';


GO
--[9] 현재 사용자가 취득하지 못한 그룹 정보를 읽어오기 : Everyone 제외
Create Proc dbo.GetGroupNotInUse
    @UID Int
As
    Select UID As GroupUID, DomainID, Name 
    From Groups
    Where UID NOT IN (
            Select GroupUID	From Membership
            Where UserUID = @UID
        )
        And 
        DomainID <> 'Everyone'
    Order By DomainID
GO
PRINT N'[dbo].[GetGroups]을(를) 만드는 중...';


GO
--[11] 그룹리스트를 출력하는 저장 프로시저 : GetGroups
Create Proc dbo.GetGroups
As
    Select [UID], [DomainID], [Name], [Type], [Description] 
	From Groups 
	Order By UID ASC
GO
PRINT N'[dbo].[GetLogsWithPaging]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[GetLogsWithPaging]
	@PageIndex int = 0,		-- @PageIndex : 페이지 인덱스 : 0, 1, 2, ...
	@PageSize int = 10		-- @PageSize : 한 페이지에 표시할 레코드 수
AS
	Select 
		[RowNumbers], 
		[Id], 
		[Note], 
		[Application], 
		[Logger], 
		[LogEvent], 
		[Message], 
		[MessageTemplate], 
		[Level], 
		[TimeStamp], 
		[Exception], 
		[Properties], 
		[Callsite], 
		[IpAddress]
	From 
		(
			Select 
				ROW_NUMBER() Over (Order By Id Desc) As RowNumbers, 
				[Id], 
				[Note], 
				[Application], 
				[Logger], 
				[LogEvent], 
				[Message], 
				[MessageTemplate], 
				[Level], 
				[TimeStamp], 
				[Exception], 
				[Properties], 
				[Callsite], 
				[IpAddress] 
			From Logs 
		)
		As TempRowTables
	Where 
		RowNumbers 
			Between 
				(@PageIndex * @PageSize + 1) 
			And 
				(@PageIndex + 1) * @PageSize
GO
PRINT N'[dbo].[GetUser]을(를) 만드는 중...';


GO
--[3] 현재 접속자에 대한 모든 정보를 출력 : GetUser : UserInfor.aspx에서 사용
Create Proc dbo.GetUser
    @DomainID NVarChar(30)
As
    Select 
		[UID], [DomainID], [Name], [CreatedDate], [Password], [Email], 
		[LastLoginDate], [LastLoginIP], [VisitedCount], [Description], 
		[Blocked], [Type], [PhoneNumber], [Address], [Gender], 
		[BirthDate], [Country] 
	From Users 
	Where DomainID = @DomainID
GO
PRINT N'[dbo].[LoginUser]을(를) 만드는 중...';


GO
------------------------------------------------------------------------------------------------------
--[!] 저장 프로시저(Stored Procedure) 설계 - 회원 인증 관련
------------------------------------------------------------------------------------------------------

--[2] 회원 로그인 처리 저장 프로시저 : LoginUser : /Login/, Login.aspx, LoginForm.aspx에서 사용
Create Proc dbo.LoginUser
    @DomainID NVarChar(30), 
    @Password NVarChar(50),
    @LastLoginIP NVarChar(15), -- IP주소(입력)
    @OriginLastLoginIP NVarChar(15) Output, -- 이전 IP주소 반환용
    @OriginLastLoginDate DateTime Output   -- 마지막 로그인 시간
As
BEGIN
	
	Set @OriginLastLoginIP = ''
	Set @OriginLastLoginDate = NULL

    Declare @Result Int
    Declare @UID Int	-- UID 고유번호
    Declare @Name NVarChar(30) 
    Select @Result = Count(*), @UID = UID, @Name = Name From Users -- 뷰에서 검색
    Where DomainID = @DomainID And Password = @Password
    Group By UID, Name

    If @Result > 0 -- 로그인 정보 남기기
    Begin
        -- 이전 자료 읽어서 반환
        Select @OriginLastLoginIP = LastLoginIP, 
            @OriginLastLoginDate = LastLoginDate 
        From Users Where UID = @UID
        
        If @OriginLastLoginDate Is Null
            Set @OriginLastLoginDate = GETDATE()
        
        -- 새로운 값으로 업데이트
        Update UserProfiles
        Set 
            LastLoginIP = @LastLoginIP, 
            LastLoginDate = GetDate(),
            VisitedCount = VisitedCount + 1
        Where UID = @UID 	


        -- 로그인 히스토리 테이블에 기록
        Insert LoginHistories(UID, UserID, UserName, LoginIP, LoginDate) 
		Values(@UID, @DomainID, @Name, @LastLoginIP, GetDate())		


        Select '1'
    End
    Else
    Begin	
        If @OriginLastLoginDate Is Null
            Set @OriginLastLoginDate = GETDATE()
        Select '0' -- 0 : 아이디 및 암호 틀림, 1 : Correct
    End
END
GO
PRINT N'[dbo].[SaveAddress]을(를) 만드는 중...';


GO
CREATE procedure [dbo].[SaveAddress]
	@Id            int output,
	@ContactId     int,
	@AddressType   varchar(10),
	@StreetAddress varchar(50),
	@City          varchar(50),
	@StateId       int,
	@PostalCode    varchar(20)
AS
BEGIN
	UPDATE	Addresses
	SET		ContactId     = @ContactId,
	        AddressType   = @AddressType,
	        StreetAddress = @StreetAddress,
			City          = @City,
			StateId       = @StateId,
			PostalCode    = @PostalCode
	WHERE	Id            = @Id

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO Addresses
		(ContactId, AddressType, StreetAddress, City, StateId, PostalCode)
		VALUES (@ContactId, @AddressType, @StreetAddress, @City, @StateId, @PostalCode);
		
		SET @Id = cast(scope_identity() as int)
	END;
END;
GO
PRINT N'[dbo].[SaveContact]을(를) 만드는 중...';


GO
create procedure [dbo].[SaveContact]
	@Id     	int output,
	@FirstName	varchar(50),
	@LastName	varchar(50),	
	@Company	varchar(50),
	@Title		varchar(50),
	@Email		varchar(50)
AS
BEGIN
	UPDATE	Contacts
	SET		FirstName = @FirstName,
			LastName  = @LastName,
			Company   = @Company,
			Title     = @Title,
			Email     = @Email
	WHERE	Id        = @Id

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [dbo].[Contacts]
           ([FirstName]
           ,[LastName]
           ,[Company]
           ,[Title]
           ,[Email])
		VALUES
           (@FirstName,
           @LastName, 
           @Company,
           @Title,
           @Email);
		SET @Id = cast(scope_identity() as int)
	END;
END;
GO
PRINT N'[dbo].[UpdateGroupAdmin]을(를) 만드는 중...';


GO
--[12] 관리자가 그룹 정보 업데이트: 나중에 그룹명 변경하는 로직 추가할 것...
Create Proc dbo.UpdateGroupAdmin
    @DomainID NVarChar(30),		-- 현재 사용자
    @Name NVarChar(50),			-- 이름
    @Description NVarChar(255),	-- 설명(소개)
    @UID Int					-- 현재 그룹 UID
As
    --[!] 해당 그룹이 이미 등록되어있으면
    Declare @Result Int
    Select @Result = Count(*) From Domains Where DomainID = @DomainID

    If @Result > 0 
        Return -1 -- -1이 반환되면 회원가입 안됨...
        
    Begin
        Update Domains  -- 아이디, 이름, 설명
        Set 
            DomainID = @DomainID, Name = @Name, 
            Description = @Description 
        Where UID = @UID
    End
    Select @@RowCount -- 업데이트된 내용이 있으면 1반환
GO
PRINT N'[dbo].[UpdateUser]을(를) 만드는 중...';


GO
--[6] 현재 접속자의 프로필 정보를 업데이트 : UpdateUser
Create Proc dbo.UpdateUser
    @Email NVarChar(100),		-- 이메일
    @Description NVarChar(255),	-- 설명(소개)
    @DomainID NVarChar(30),		-- 현재 접속자

	@PhoneNumber NVarChar(30) = NULL,
	@Address NVarChar(100) = NULL,
	@Gender NVarChar(10) = NULL,
	@BirthDate NVarChar(20) = NULL,
	@Country NVarChar(50) = NULL

As
    Declare @UID Int
    Select @UID = UID From Domains Where DomainID = @DomainID

    If @UID Is Not Null
    Begin
        Update Domains Set Description = @Description 
        Where UID = @UID

        Update UserProfiles 
			Set Email = @Email, PhoneNumber = @PhoneNumber, 
				Address = @Address, Gender = @Gender, 
				BirthDate = @BirthDate, Country = @Country 
        Where UID = @UID
    End

    Select @@RowCount -- 업데이트된 내용이 있으면 1반환
GO
PRINT N'[dbo].[UpdateUserAdmin]을(를) 만드는 중...';


GO
--[7] 관리자가 사용자 정보 업데이트
Create Proc dbo.UpdateUserAdmin
    @DomainID NVarChar(30),		-- 현재 사용자
    @Name NVarChar(50),			-- 이름
    @Password NVarChar(50),		-- 암호
    @Email NVarChar(100),		-- 이메일
    @Description NVarChar(255),	-- 설명(소개)
    @Blocked Bit,				-- 잠금 여부(0 또는 1)
    @UID Int,					-- 현재 사용자 UID

	@PhoneNumber NVarChar(50) = NULL,
	@Address NVarChar(100) = NULL,
	@Gender NVarChar(10) = NULL,
	@BirthDate NVarChar(20) = NULL,
	@Country NVarChar(50) = NULL
	
As
    -- 아이디 변경은 따로 구현할 것...
    --[!] 해당 아이디가 이미 회원가입되어있으면
    --Declare @Result Int
    --Select @Result = Count(*) From Domains Where DomainID = @DomainID

    --If @Result > 0 
    --    Return -1 -- -1이 반환되면 회원가입 안됨...
        
    Begin
        Update Domains  -- 아이디, 이름, 설명
        Set 
            DomainID = @DomainID, Name = @Name, Description = @Description 
        Where UID = @UID

		-- 이메일, 암호, 잠금 여부
        Update UserProfiles 
		Set 
			Email = @Email, Password = @Password, Blocked = @Blocked, 
			PhoneNumber = @PhoneNumber, Address = @Address, Gender = @Gender, 
			BirthDate = @BirthDate, Country = @Country  
        Where UID = @UID
    End
    Select @@RowCount -- 업데이트된 내용이 있으면 1반환
GO
DECLARE @VarDecimalSupported AS BIT;

SELECT @VarDecimalSupported = 0;

IF ((ServerProperty(N'EngineEdition') = 3)
    AND (((@@microsoftversion / power(2, 24) = 9)
          AND (@@microsoftversion & 0xffff >= 3024))
         OR ((@@microsoftversion / power(2, 24) = 10)
             AND (@@microsoftversion & 0xffff >= 1600))))
    SELECT @VarDecimalSupported = 1;

IF (@VarDecimalSupported > 0)
    BEGIN
        EXECUTE sp_db_vardecimal_storage_format N'$(DatabaseName)', 'ON';
    END


GO
PRINT N'업데이트가 완료되었습니다.';


GO
