﻿/*
DNNAN의 배포 스크립트

이 코드는 도구를 사용하여 생성되었습니다.
파일 내용을 변경하면 잘못된 동작이 발생할 수 있으며, 코드를 다시 생성하면
변경 내용이 손실됩니다.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "DNNAN"
:setvar DefaultFilePrefix "DNNAN"
:setvar DefaultDataPath "C:\Users\RedPlus\AppData\Local\Microsoft\Microsoft SQL Server Local DB\Instances\MSSQLLocalDb"
:setvar DefaultLogPath "C:\Users\RedPlus\AppData\Local\Microsoft\Microsoft SQL Server Local DB\Instances\MSSQLLocalDb"

GO
:on error exit
GO
/*
SQLCMD 모드가 지원되지 않으면 SQLCMD 모드를 검색하고 스크립트를 실행하지 않습니다.
SQLCMD 모드를 설정한 후에 이 스크립트를 다시 사용하려면 다음을 실행합니다.
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'이 스크립트를 실행하려면 SQLCMD 모드를 사용하도록 설정해야 합니다.';
        SET NOEXEC ON;
    END


GO
USE [$(DatabaseName)];


GO
PRINT N'[dbo].[Attendees]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Attendees] (
    [Id]           INT           IDENTITY (1, 1) NOT NULL,
    [UID]          INT           NOT NULL,
    [UserID]       NVARCHAR (25) NOT NULL,
    [Name]         NVARCHAR (25) NOT NULL,
    [CreationDate] DATETIME      NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Characters]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Characters] (
    [Id]       INT           IDENTITY (1, 1) NOT NULL,
    [Username] NVARCHAR (25) NOT NULL,
    [HeroId]   INT           NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[CommunityCampJoinMembers]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[CommunityCampJoinMembers] (
    [Id]            INT            IDENTITY (1, 1) NOT NULL,
    [CommunityName] NVARCHAR (25)  NOT NULL,
    [Name]          NVARCHAR (25)  NOT NULL,
    [Mobile]        NVARCHAR (30)  NOT NULL,
    [Email]         NVARCHAR (100) NOT NULL,
    [Size]          NVARCHAR (10)  NOT NULL,
    [CreationDate]  DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Fives]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Fives] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Fours]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Fours] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Heroes]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Heroes] (
    [Id]      INT                IDENTITY (1, 1) NOT NULL,
    [Name]    NVARCHAR (50)      NOT NULL,
    [Icon]    NVARCHAR (255)     NULL,
    [Created] DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Ideas]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Ideas] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Maxims]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Maxims] (
    [Id]           INT            IDENTITY (1, 1) NOT NULL,
    [Name]         NVARCHAR (25)  NOT NULL,
    [Content]      NVARCHAR (255) NULL,
    [CreationDate] DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Memos]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Memos] (
    [Num]      INT            IDENTITY (1, 1) NOT NULL,
    [Name]     NVARCHAR (25)  NOT NULL,
    [Email]    NVARCHAR (100) NULL,
    [Title]    NVARCHAR (150) NOT NULL,
    [PostDate] DATETIME       NULL,
    [PostIp]   NVARCHAR (15)  NULL,
    PRIMARY KEY CLUSTERED ([Num] ASC)
);


GO
PRINT N'[dbo].[NoteComments]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[NoteComments] (
    [Id]        INT             IDENTITY (1, 1) NOT NULL,
    [BoardName] NVARCHAR (50)   NULL,
    [BoardId]   INT             NOT NULL,
    [Name]      NVARCHAR (25)   NOT NULL,
    [Opinion]   NVARCHAR (4000) NOT NULL,
    [PostDate]  SMALLDATETIME   NULL,
    [Password]  NVARCHAR (255)  NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Notes]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Notes] (
    [Id]           INT            IDENTITY (1, 1) NOT NULL,
    [Name]         NVARCHAR (25)  NOT NULL,
    [Email]        NVARCHAR (100) NULL,
    [Title]        NVARCHAR (150) NOT NULL,
    [PostDate]     DATETIME       NOT NULL,
    [PostIp]       NVARCHAR (15)  NULL,
    [Content]      NTEXT          NOT NULL,
    [Password]     NVARCHAR (255) NULL,
    [ReadCount]    INT            NULL,
    [Encoding]     NVARCHAR (10)  NOT NULL,
    [Homepage]     NVARCHAR (100) NULL,
    [ModifyDate]   DATETIME       NULL,
    [ModifyIp]     NVARCHAR (15)  NULL,
    [FileName]     NVARCHAR (255) NULL,
    [FileSize]     INT            NULL,
    [DownCount]    INT            NULL,
    [Ref]          INT            NOT NULL,
    [Step]         INT            NULL,
    [RefOrder]     INT            NULL,
    [AnswerNum]    INT            NULL,
    [ParentNum]    INT            NULL,
    [CommentCount] INT            NULL,
    [Category]     NVARCHAR (10)  NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Ones]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Ones] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[PointLogs]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[PointLogs] (
    [Id]       INT                IDENTITY (1, 1) NOT NULL,
    [UserId]   INT                NOT NULL,
    [Username] NVARCHAR (25)      NULL,
    [NowPoint] INT                NULL,
    [Created]  DATETIMEOFFSET (7) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Points]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Points] (
    [Id]         INT           IDENTITY (1, 1) NOT NULL,
    [UserId]     INT           NOT NULL,
    [Username]   NVARCHAR (25) NULL,
    [TotalPoint] INT           NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Questions]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Questions] (
    [Id]    INT            IDENTITY (1, 1) NOT NULL,
    [Title] NVARCHAR (MAX) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[RecruitRegistrations]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[RecruitRegistrations] (
    [Id]               INT                IDENTITY (1, 1) NOT NULL,
    [RecruitSettingId] INT                NULL,
    [BoardName]        NVARCHAR (50)      NULL,
    [BoardNum]         INT                NULL,
    [BoardTitle]       NVARCHAR (150)     NULL,
    [CreationDate]     DATETIMEOFFSET (7) NULL,
    [UserId]           INT                NULL,
    [Username]         NVARCHAR (25)      NOT NULL,
    [NickName]         NVARCHAR (100)     NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[RecruitSettings]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[RecruitSettings] (
    [Id]           INT                IDENTITY (1, 1) NOT NULL,
    [Remarks]      NVARCHAR (MAX)     NULL,
    [CreationDate] DATETIMEOFFSET (7) NULL,
    [BoardName]    NVARCHAR (50)      NULL,
    [BoardNum]     INT                NOT NULL,
    [BoardTitle]   NVARCHAR (150)     NULL,
    [BoardContent] NVARCHAR (4000)    NULL,
    [StartDate]    SMALLDATETIME      NULL,
    [EventDate]    SMALLDATETIME      NULL,
    [EndDate]      SMALLDATETIME      NULL,
    [MaxCount]     INT                NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Tasks]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Tasks] (
    [Id]           INT            IDENTITY (1, 1) NOT NULL,
    [Title]        NVARCHAR (140) NOT NULL,
    [IsCompleted]  BIT            NULL,
    [CreationDate] DATETIME       NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Teches]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Teches] (
    [Id]    INT           IDENTITY (1, 1) NOT NULL,
    [Title] NVARCHAR (50) NOT NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Threes]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Threes] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Twos]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Twos] (
    [Id]   INT            IDENTITY (1, 1) NOT NULL,
    [Note] NVARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[UserLogs]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[UserLogs] (
    [Id]                               INT           IDENTITY (1, 1) NOT NULL,
    [Username]                         NVARCHAR (50) NOT NULL,
    [FailedPasswordAttemptCount]       INT           NULL,
    [FailedPasswordAttemptWindowStart] DATETIME      NULL,
    PRIMARY KEY CLUSTERED ([Id] ASC)
);


GO
PRINT N'[dbo].[Users]을(를) 만드는 중...';


GO
CREATE TABLE [dbo].[Users] (
    [UID]      INT            IDENTITY (1, 1) NOT NULL,
    [UserID]   NVARCHAR (25)  NOT NULL,
    [Password] NVARCHAR (255) NOT NULL,
    [Username] NVARCHAR (20)  NULL,
    PRIMARY KEY CLUSTERED ([UID] ASC)
);


GO
PRINT N'[dbo].[Attendees]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Attendees]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[CommunityCampJoinMembers]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[CommunityCampJoinMembers]
    ADD DEFAULT ('L') FOR [Size];


GO
PRINT N'[dbo].[CommunityCampJoinMembers]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[CommunityCampJoinMembers]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[Heroes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Heroes]
    ADD DEFAULT (GetDate()) FOR [Created];


GO
PRINT N'[dbo].[Maxims]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Maxims]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[Memos]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Memos]
    ADD DEFAULT (getdate()) FOR [PostDate];


GO
PRINT N'[dbo].[NoteComments]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[NoteComments]
    ADD DEFAULT (GetDate()) FOR [PostDate];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT GetDate() FOR [PostDate];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [ReadCount];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [FileSize];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [DownCount];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [Step];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [RefOrder];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [AnswerNum];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [ParentNum];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT 0 FOR [CommentCount];


GO
PRINT N'[dbo].[Notes]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Notes]
    ADD DEFAULT ('Free') FOR [Category];


GO
PRINT N'[dbo].[PointLogs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[PointLogs]
    ADD DEFAULT (1) FOR [NowPoint];


GO
PRINT N'[dbo].[PointLogs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[PointLogs]
    ADD DEFAULT (GetDate()) FOR [Created];


GO
PRINT N'[dbo].[Points]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Points]
    ADD DEFAULT (0) FOR [TotalPoint];


GO
PRINT N'[dbo].[RecruitRegistrations]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[RecruitRegistrations]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[RecruitSettings]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[RecruitSettings]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[RecruitSettings]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[RecruitSettings]
    ADD DEFAULT (1000) FOR [MaxCount];


GO
PRINT N'[dbo].[Tasks]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[Tasks]
    ADD DEFAULT (GetDate()) FOR [CreationDate];


GO
PRINT N'[dbo].[UserLogs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[UserLogs]
    ADD DEFAULT (0) FOR [FailedPasswordAttemptCount];


GO
PRINT N'[dbo].[UserLogs]에 대한 명명되지 않은 제약 조건을(를) 만드는 중...';


GO
ALTER TABLE [dbo].[UserLogs]
    ADD DEFAULT (GetDate()) FOR [FailedPasswordAttemptWindowStart];


GO
PRINT N'[dbo].[DeleteMemo]을(를) 만드는 중...';


GO

--[e] 메모 데이터 삭제용 저장 프로시저
Create Proc dbo.DeleteMemo
(
	@Num Int
)
As
	Delete Memos
	Where Num = @Num
GO
PRINT N'[dbo].[DeleteNote]을(를) 만드는 중...';


GO
--[7] 해당 글을 지우는 저장 프로시저: 답변글이 있으면 업데이트하고 없으면 지운다.
Create Proc dbo.DeleteNote
    @Id Int,
    @Password NVarChar(255) -- 암호 매개변수 추가
As
    Declare @cnt Int
    Select @cnt = Count(*) From Notes
    Where Id = @Id And Password = @Password

    If @cnt = 0
    Begin
        Return 0 -- 번호와 암호가 맞는게 없으면 0을 반환
    End	

    Declare @AnswerNum Int
    Declare @RefOrder Int
    Declare @Ref Int
    Declare @ParentNum Int

    Select
        @AnswerNum = AnswerNum,     @RefOrder = RefOrder,
        @Ref = Ref,                 @ParentNum = ParentNum
    From Notes
    Where Id = @Id

    If @AnswerNum = 0
    Begin
        If @RefOrder > 0 
        Begin
            UPDATE Notes SET RefOrder = RefOrder - 1
            WHERE Ref = @Ref AND RefOrder > @RefOrder
            UPDATE Notes SET AnswerNum = AnswerNum - 1 WHERE Id = @ParentNum
        End
        Delete Notes Where Id = @Id
        Delete Notes 
        WHERE 
            Id = @ParentNum AND ModifyIp = N'((DELETED))' AND AnswerNum = 0	
    End
    Else
    Begin
        Update Notes 
        Set 
            Name = N'(Unknown)', Email = '', Password = '',
            Title = N'(삭제된 글입니다.)', 
            Content = N'(삭제된 글입니다. ' 
            + N'현재 답변이 포함되어 있기 때문에 내용만 삭제되었습니다.)',
            ModifyIp = N'((DELETED))', FileName = '', 
            FileSize = 0, CommentCount = 0
        Where Id = @Id  
    End
GO
PRINT N'[dbo].[DeleteUsers]을(를) 만드는 중...';


GO
--ModifyUsers 'master', '1234', 2


--[5] 삭제 저장 프로시저
Create Proc dbo.DeleteUsers
	@UID Int
As
	Delete Users Where UID = @UID
GO
PRINT N'[dbo].[GetCountNotes]을(를) 만드는 중...';


GO
--[5] DotNetNote 테이블에 있는 레코드의 개수를 구하는 저장 프로시저
Create Proc dbo.GetCountNotes
As
    Select Count(*) From Notes
GO
PRINT N'[dbo].[GetUsers]을(를) 만드는 중...';


GO
CREATE PROCEDURE [dbo].[GetUsers]
	@UID int = 0
AS
	Select [UID], [UserID], [Password], [Username] 
	From Users 
	Where UID = @UID
GO
PRINT N'[dbo].[ListMemo]을(를) 만드는 중...';


GO

--[b] 메모 출력용 저장 프로시저
Create Proc dbo.ListMemo
As
	Select Num, Name, Email, Title, PostDate, PostIp
	From Memos Order By Num Desc
GO
PRINT N'[dbo].[ListNotes]을(를) 만드는 중...';


GO
--[2] 게시판(DotNetNote)에서 데이터 출력 : ListNotes
Create Procedure dbo.ListNotes
    @Page Int
As
    With DotNetNoteOrderedLists 
    As 
    (
        Select 
            [Id], [Name], [Email], [Title], [PostDate], [ReadCount], 
            [Ref], [Step], [RefOrder], [AnswerNum], [ParentNum], 
            [CommentCount], [FileName], [FileSize], [DownCount], 
            ROW_NUMBER() Over (Order By Ref Desc, RefOrder Asc) 
            As 'RowNumber' 
        From Notes
    ) 
    Select * From DotNetNoteOrderedLists 
    Where RowNumber Between @Page * 10 + 1 And (@Page + 1) * 10
GO
PRINT N'[dbo].[ListUsers]을(를) 만드는 중...';


GO
--WriteUsers 'redplus', '1234'


--[2] 출력 저장 프로시저
--Create Proc dbo.ListUsers
--As
--	Select * From Users Order By UID Desc
--Go
Create Proc dbo.ListUsers
As
	Select [UID], [UserID], [Password] From Users Order By UID Desc
GO
PRINT N'[dbo].[ModifyMemo]을(를) 만드는 중...';


GO

--[d] 메모 데이터 수정용 저장 프로시저
Create Proc dbo.ModifyMemo
(
	@Name NVarChar(25),
	@Email NVarChar(100),
	@Title NVarChar(150),
	@Num Int 
)
As
Begin Transaction
	Update Memos 
	Set 
		Name = @Name, 
		Email = @Email,
		Title = @Title
	Where Num = @Num
Commit Transaction
GO
PRINT N'[dbo].[ModifyNote]을(를) 만드는 중...';


GO
--[8] 해당 글을 수정하는 저장 프로시저 : ModifyNote
Create Proc dbo.ModifyNote
    @Name       NVarChar(25), 
    @Email      NVarChar(100), 
    @Title      NVarChar(150), 
    @ModifyIp   NVarChar(15), 
    @Content    NText,
    @Password   NVarChar(255), 
    @Encoding   NVarChar(10), 
    @Homepage   NVarChar(100),
    @FileName	NVarChar(255),
    @FileSize	Int,
    
    @Id Int
As
    Declare @cnt Int

    Select @cnt = Count(*) From Notes 
    Where Id = @Id And Password = @Password

    If @cnt > 0 -- 번호와 암호가 맞는게 있다면...
    Begin
        Update Notes 
        Set 
            Name = @Name, Email = @Email, Title = @Title,
            ModifyIp = @ModifyIp, ModifyDate = GetDate(),
            Content = @Content, Encoding = @Encoding,
            Homepage = @Homepage, FileName = @FileName, FileSize = @FileSize
        Where Id = @Id

        Select '1'
    End
    Else
        Select '0'
GO
PRINT N'[dbo].[ModifyUsers]을(를) 만드는 중...';


GO
--ViewUsers 5


--[4] 수정 저장 프로시저
Create Proc dbo.ModifyUsers
	@UserID NVarChar(25),
	@Password NVarChar(255),
	@UID Int
As
	Begin Tran
		Update Users
		Set	
			UserID = @UserID,
			[Password] = @Password
		Where UID = @UID
	Commit Tran
GO
PRINT N'[dbo].[ReplyNote]을(를) 만드는 중...';


GO
--[4] 게시판(DotNetNote)에 글을 답변 : ReplyNote
Create Proc dbo.ReplyNote
    @Name       NVarChar(25), 
    @Email      NVarChar(100), 
    @Title      NVarChar(150), 
    @PostIp     NVarChar(15), 
    @Content    NText, 
    @Password   NVarChar(255), 
    @Encoding   NVarChar(10), 
    @Homepage   NVarChar(100),
    @ParentNum  Int,                -- 부모글의 고유번호(Id)
    @FileName   NVarChar(255),
    @FileSize   Int
As
    --[0] 변수 선언
    Declare @MaxRefOrder Int
    Declare @MaxRefAnswerNum Int
    Declare @ParentRef Int
    Declare @ParentStep Int
    Declare @ParentRefOrder Int

    --[1] 부모글의 답변수(AnswerNum)를 1증가
    Update Notes Set AnswerNum = AnswerNum + 1 Where Id = @ParentNum 

    --[2] 같은 글에 대해서 답변을 두 번 이상하면 먼저 답변한 게 위에 나타나게 한다.
    Select @MaxRefOrder = RefOrder, @MaxRefAnswerNum = AnswerNum From Notes 
    Where 
        ParentNum = @ParentNum And 
        RefOrder = 
            (Select Max(RefOrder) From Notes Where ParentNum = @ParentNum)

    If @MaxRefOrder Is Null
    Begin
        Select @MaxRefOrder = RefOrder From Notes Where Id = @ParentNum
        Set @MaxRefAnswerNum = 0  
    End 

    --[3] 중간에 답변달 때(비집고 들어갈 자리 마련)
    Select 
        @ParentRef = Ref, @ParentStep = Step 
    From Notes Where Id = @ParentNum

    Update Notes 
    Set 
        RefOrder = RefOrder + 1 
    Where 
        Ref = @ParentRef And RefOrder > (@MaxRefOrder + @MaxRefAnswerNum)

    --[4] 최종저장
    Insert Notes
    (
        Name, Email, Title, PostIp, Content, Password, Encoding, 
        Homepage, Ref, Step, RefOrder, ParentNum, FileName, FileSize
    )
    Values
    (
        @Name, @Email, @Title, @PostIp, @Content, @Password, @Encoding, 
        @Homepage, @ParentRef, @ParentStep + 1, 
        @MaxRefOrder + @MaxRefAnswerNum + 1, @ParentNum, @FileName, @FileSize
    )
GO
PRINT N'[dbo].[SearchMemo]을(를) 만드는 중...';


GO

--[f] 메모 데이터 검색용 저장 프로시저(동적SQL 사용)
Create Proc dbo.SearchMemo
(
	@SearchField NVarChar(10),
	@SearchQuery NVarChar(50)
)
-- With Encryption -- 현재 SP문 암호화
As
	Declare @strSql NVarChar(250) -- 변수 선언
	Set @strSql = 
		'
		Select Num, Name, Email, Title, PostDate, PostIp 
		From Memos
		Where ' + @SearchField + ' Like 
			N''%' + @SearchQuery + '%''
		Order By Num Desc
		'
	--Print @strSql
	Exec (@strSql) --완성된 SQL문 실행
GO
PRINT N'[dbo].[SearchNoteCount]을(를) 만드는 중...';


GO
--[6] 검색 결과의 레코드 수 반환
Create Proc dbo.SearchNoteCount
    @SearchField NVarChar(25),
    @SearchQuery NVarChar(25)
As
    Set @SearchQuery = '%' + @SearchQuery + '%'

    Select Count(*)
    From Notes
    Where
    (
        Case @SearchField 
            When 'Name' Then [Name]
            When 'Title' Then Title
            When 'Content' Then Content
            Else @SearchQuery
        End
    ) 
    Like 
    @SearchQuery
GO
PRINT N'[dbo].[SearchNotes]을(를) 만드는 중...';


GO
--[9] 게시판(DotNetNote)에서 데이터 검색 리스트 : SearchNotes
Create Procedure dbo.SearchNotes
    @Page Int,
    @SearchField NVarChar(25),
    @SearchQuery NVarChar(25)
As
    With DotNetNoteOrderedLists 
    As 
    (
        Select 
            [Id], [Name], [Email], [Title], [PostDate], 
            [ReadCount], [Ref], [Step], [RefOrder], [AnswerNum], 
            [ParentNum], [CommentCount], [FileName], [FileSize], 
            [DownCount], 
            ROW_NUMBER() Over (Order By Ref Desc, RefOrder Asc) 
            As 'RowNumber' 
        From Notes
        Where ( 
            Case @SearchField 
                When 'Name' Then [Name] 
                When 'Title' Then Title 
                When 'Content' Then Content 
                Else 
                @SearchQuery 
            End 
        ) Like '%' + @SearchQuery + '%'
    ) 
    Select 
        [Id], [Name], [Email], [Title], [PostDate], 
        [ReadCount], [Ref], [Step], [RefOrder], 
        [AnswerNum], [ParentNum], [CommentCount], 
        [FileName], [FileSize], [DownCount], 
        [RowNumber] 
    From DotNetNoteOrderedLists 
    Where RowNumber Between @Page * 10 + 1 And (@Page + 1) * 10  
    Order By Id Desc
GO
PRINT N'[dbo].[SearchUsers]을(를) 만드는 중...';


GO
--DeleteUsers 2


--[6] 검색 저장 프로시저
Create Proc dbo.SearchUsers
	@SearchField NVarChar(25),
	@SearchQuery NVarChar(25)
As
	Declare @strSql NVarChar(255)
	Set @strSql = '
		Select * From Users 
		Where 
			' + @SearchField + ' Like ''%' + @SearchQuery + '%''
	'
	-- Print @strSql
	Exec(@strSql)
GO
PRINT N'[dbo].[ViewMemo]을(를) 만드는 중...';


GO

--[c] 메모 상세 보기용 저장 프로시저
Create Proc dbo.ViewMemo
(
	@Num Int
)
As
	Select Num, Name, Email, Title, PostDate, PostIp 
	From Memos 
	Where Num = @Num
GO
PRINT N'[dbo].[ViewNote]을(를) 만드는 중...';


GO
--[3] 해당 글을 세부적으로 읽어오는 저장 프로시저 : ViewNote
Create Procedure dbo.ViewNote
    @Id Int
As
    -- 조회수 카운트 1증가
    Update Notes Set ReadCount = ReadCount + 1 Where Id = @Id
    
    -- 모든 항목 조회
    Select * From Notes Where Id = @Id
GO
PRINT N'[dbo].[ViewUsers]을(를) 만드는 중...';


GO
--ListUsers


--[3] 상세 저장 프로시저
Create Proc dbo.ViewUsers
	@UID Int
As
	Select [UID], [UserID], [Password] From Users Where UID = @UID
GO
PRINT N'[dbo].[WriteMemo]을(를) 만드는 중...';


GO
--[3] SQL 저장 프로시저 6가지 작성

--[a] 메모 입력용 저장 프로시저
Create Procedure dbo.WriteMemo
(
	@Name NVarChar(25),
	@Email NVarChar(100),
	@Title NVarChar(150),
	@PostIp NVarChar(15)
)
As
	Insert Memos(Name, Email, Title, PostIp)
	Values(@Name, @Email, @Title, @PostIp)
GO
PRINT N'[dbo].[WriteNote]을(를) 만드는 중...';


GO
--[1] 게시판(DotNetNote)에 글을 작성 : WriteNote
Create Proc dbo.WriteNote
    @Name       NVarChar(25), 
    @Email      NVarChar(100), 
    @Title      NVarChar(150), 
    @PostIp     NVarChar(15), 
    @Content    NText, 
    @Password   NVarChar(255), 
    @Encoding   NVarChar(10), 
    @Homepage   NVarChar(100),
    @FileName   NVarChar(255),
    @FileSize   Int,
	@Category   NVarChar(10) 
As
    Declare @MaxRef Int
    Select @MaxRef = Max(Ref) From Notes
 
    If @MaxRef is Null
        Set @MaxRef = 1 -- 테이블 생성 후 처음만 비교
    Else
        Set @MaxRef = @MaxRef + 1

    Insert Notes
    (
        Name, Email, Title, PostIp, Content, Password, Encoding, 
        Homepage, Ref, FileName, FileSize,
		Category 
    )
    Values
    (
        @Name, @Email, @Title, @PostIp, @Content, @Password, @Encoding, 
        @Homepage, @MaxRef, @FileName, @FileSize,
		@Category
    )
GO
PRINT N'[dbo].[WriteUsers]을(를) 만드는 중...';


GO
--[User][0][2] Users 관련 저장 프로시저 생성

--[1] 입력 저장 프로시저
Create Proc dbo.WriteUsers
	@UserID NVarChar(25),
	@Password NVarChar(255)
As
	Insert Into Users Values(@UserID, @Password)
GO
PRINT N'업데이트가 완료되었습니다.';


GO
