﻿using DotNetNote.Models;
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;
using System.Linq;
using System.Net;

namespace AngularNote.Controllers
{
    [Route("api/[controller]")]
    public class IdeaServiceController : Controller
    {
        private IIdeaRepository repository; 
        public IdeaServiceController(IIdeaRepository repo)
        {
            repository = repo; 
        }

        [HttpGet]
        public IEnumerable<Idea> Get()
        {
            return repository.GetAll().AsEnumerable(); 
        }

        [HttpGet("{id}")]
        public Idea Get(int id)
        {
            var idea = repository.GetAll().Where(m => m.Id == id).Single();
            if (idea == null)
            {
                Response.StatusCode = (int)HttpStatusCode.NotFound;
                return null; 
            }
            return idea; 
        }

        [HttpPost]
        public JsonResult Post([FromBody]Idea model)
        {
            if (ModelState.IsValid)
            {
                // 데이터 입력
                var m = repository.Add(model); 

                Response.StatusCode = (int)HttpStatusCode.Created;
                return Json(m);
            }
            else
            {
                Response.StatusCode = (int)HttpStatusCode.BadRequest;
                return Json(new { Message = "실패", ModelState = ModelState });
            }
        }
    }
}
